// Evaluates the river and returns the best type of hand possible
function check3cards() {
	var cards = new Array(3);
	
	cards[0] = game.river[0];
	cards[1] = game.river[1];
	cards[2] = game.river[2];
	
	var suits = [checkMyType(cards, 's'), checkMyType(cards, 'c'), checkMyType(cards, 'h'), checkMyType(cards, 'd')];
	
	cards.sort (
		function(a, b) {
			var aVal;
			var bVal;
			if (a.val == 'T')
				a.val = 10;
			else if (a.val == 'J')
				a.val = 11;
			else if (a.val == 'Q')
				a.val = 12;
			else if (a.val == 'K')
				a.val = 13;
			else if (a.val == 'A')
				a.val = 1;
			aVal = a.val;
				
			if (b.val == 'T')
				b.val = 10;
			else if (b.val == 'J')
				b.val = 11;
			else if (b.val == 'Q')
				b.val = 12;
			else if (b.val == 'K')
				b.val = 13;
			else if (b.val == 'A')
				b.val = 1;
			bVal = b.val;
				
			return aVal - bVal;
		}
	);
	
	if ( checkRoyalFlush(cards, suits))
	{
		return ["Royal Flush", checkRoyalFlush(cards, suits)] ;
	}
	else if ( checkStraightFlush(cards, suits))
	{
		return ["Straight Flush", checkStraightFlush(cards, suits)];
	}
	else if ( checkFourOfAKind(cards))
	{
		return ["Four of a kind", checkFourOfAKind(cards)];
	}
	else if ( checkFlush(cards, suits))
	{
		return ["Flush", checkFlush(cards, suits)];
	}
	else if (checkStraight(cards))
	{
		return ["Straight", checkStraight(cards)];
	}
	else if (checkThreeOfAKind(cards))
	{
		// Will always be the worst case scenario
		return ["Three of a kind", checkThreeOfAKind(cards)];
	}
	else
	{
		return "Error. Should not reach this line.";
	}
	
}

// Evaluates 3 specific cards and returns the best type of hand possible
function check3cardsGivenCards(cards) {
	
	var suits = [checkMyType(cards, 's'), checkMyType(cards, 'c'), checkMyType(cards, 'h'), checkMyType(cards, 'd')];
	
	cards.sort (
		function(a, b) {
			var aVal;
			var bVal;
			if (a.val == 'T')
				a.val = 10;
			else if (a.val == 'J')
				a.val = 11;
			else if (a.val == 'Q')
				a.val = 12;
			else if (a.val == 'K')
				a.val = 13;
			else if (a.val == 'A')
				a.val = 1;
			aVal = a.val;
				
			if (b.val == 'T')
				b.val = 10;
			else if (b.val == 'J')
				b.val = 11;
			else if (b.val == 'Q')
				b.val = 12;
			else if (b.val == 'K')
				b.val = 13;
			else if (b.val == 'A')
				b.val = 1;
			bVal = b.val;
				
			return aVal - bVal;
		}
	);
	
	if ( checkRoyalFlush(cards, suits))
	{
		return ["Royal Flush", checkRoyalFlush(cards, suits)] ;
	}
	else if ( checkStraightFlush(cards, suits))
	{
		return ["Straight Flush", checkStraightFlush(cards, suits)];
	}
	else if ( checkFourOfAKind(cards))
	{
		return ["Four of a kind", checkFourOfAKind(cards)];
	}
	else if ( checkFlush(cards, suits))
	{
		return ["Flush", checkFlush(cards, suits)];
	}
	else if (checkStraight(cards))
	{
		return ["Straight", checkStraight(cards)];
	}
	else if (checkThreeOfAKind(cards))
	{
		// Will always be the worst case scenario
		return ["Three of a kind", checkThreeOfAKind(cards)];
	}
	else
	{
		return "Error. Should not reach this line.";
	}
	
}

// Checks how many cards are of a certain given suit ('c' - clubs, 'h' - hearts, etc) 
function checkMyType ( cards, suit )
{
	try 
	{
		var retVal = 0;
		for (var i = 0; i < cards.length ; i++)
		{
			if (cards[i].myType == suit)
			{
				retVal++;
			}
		}
	} catch (err)
	{
	
	}
	return retVal;	
}

function checkRoyalFlush (cards, suits)
{ 
	var retCards = [[0,0],[0,0],[0,0],[0,0],[0,0]];
	
	for ( var i = 0; i < cards.length ; i++ )
	{
		if ( cards[i].val < 10 || ( cards[i].val != 1 && i != 0 ) )
		{
			return 0;
		}
	}
	if ( suits[0] != 3 && suits[1] != 3 && suits[2] != 3 && suits[3] != 3)
	{
		return 0;
	}
	else
	{
		var differenceTop = cards[2].val - cards[1].val;
		if ( differenceTop > 4 || differenceTop == 0 )
		{
			return 0;
		}
		else
		{
			var differenceLow = cards[1].val - cards[0].val;
			if ( ( differenceLow > ( 4 - differenceTop ) || differenceLow == 0 )
				&& cards[0].val != 1 )
			{
				return 0;
			}
		}
		retCards[0] = [1, cards[0].myType];
		for ( var i = 1 ; i < retCards.length ; i++ )
		{
			retCards[i] = [i+10,cards[0].myType];
		}
		return retCards;
	}
}

function checkStraightFlush (cards, suits)
{
	var retCards = [[0,0],[0,0],[0,0],[0,0],[0,0]];

	for ( var i = 0; i < cards.length-1 ; i++ )
	{
		for ( var j = i+1; j < cards.length ; j++ )
		{
			if ( cards[i].val == cards[j].val )
			{
				return 0;
			}
		}
	}
	if ( suits[0] != 3 && suits[1] != 3 && suits[2] != 3 && suits[3] != 3)
	{
		return 0;
	}
	else
	{
		var differenceTop = cards[2].val - cards[1].val;
		if ( differenceTop > 4 )
		{
			return 0;
		}
		else
		{
			var differenceLow = cards[1].val - cards[0].val;
			if ( differenceLow > ( 4 - differenceTop ) )
			{
				return 0;
			}
		}
		
		for ( var i = 0 ; i < retCards.length ; i++ )
		{
			retCards[i] = [i+cards[0].val,cards[0].myType];
		}
		return retCards;
		
	}
}

function checkFourOfAKind (cards)
{
	var retCards = [[0,0],[0,0],[0,0],[0,0],[0,0]];
	var pairFound = 0;
	
	for ( var i = 0; i < cards.length-1 ; i++ )
	{
		for ( var j = i+1; j < cards.length ; j++ )
		{
			var indices = [0,1,2];
			indices.splice(i,1);
			indices.splice(j,2);
			
			var suits = ['h','d','c','s'];
			
			if ( cards[i].val == cards[j].val )
			{
				pairFound = 1;
				suits.splice(suits.indexOf(cards[indices[0]].myType),1);
				if ( cards[i].val == 1 )
				{
					retCards = [[cards[0].val, cards[0].myType], [cards[1].val, cards[1].myType],
						[cards[2].val, cards[2].myType], [13, suits[0]], [13,suits[1]]];
				}
				else
				{
					retCards = [[cards[0].val, cards[0].myType], [cards[1].val, cards[1].myType],
						[cards[2].val, cards[2].myType], [cards[2].val, suits[0]], [cards[2].val,suits[1]]];
				}
			}
		}
	}
	
	if ( cards[0].val == cards[1].val && cards[0].val == cards[2].val )
	{
		if (cards[0].val == 1)
		{
			retCards = [[cards[0].val, cards[0].myType], [cards[1].val, cards[1].myType],
					[cards[2].val, cards[2].myType], [13, 'h'], [13,'d']];
		}
		else 
		{
			retCards = [[cards[0].val, cards[0].myType], [cards[1].val, cards[1].myType],
					[cards[2].val, cards[2].myType], [1, 'h'], [1,'d']];
		}
	}

	if ( pairFound )
	{
		return retCards;
	}
	return 0;
}

function checkFlush(cards, suits)
{
	if ( suits[0] != 3 && suits[1] != 3 && suits[2] != 3 && suits[3] != 3 )
	{
		return 0;
	}
	
	var retCards = [[0,0],[0,0],[0,0],[0,0],[0,0]];
	var values = [1,2,3,4,5,6,7,8,9,10,11,12,13];
	
	values.splice(values.indexOf(cards[0].val),1);
	values.splice(values.indexOf(cards[1].val),1);
	values.splice(values.indexOf(cards[2].val),1);
	
	retCards = [[cards[0].val, cards[0].myType], [cards[1].val, cards[1].myType], 
			[cards[2].val, cards[2].myType], [values[9].val, cards[0].myType],
			[values[10].val, cards[0].myType]];
			
	return retCards;
}

function checkStraight(cards)
{
	var retCards = [[0,0],[0,0],[0,0],[0,0],[0,0]];

	for ( var i = 0; i < cards.length-1 ; i++ )
	{
		for ( var j = i+1; j < cards.length ; j++ )
		{
			if ( cards[i].val == cards[j].val )
			{
				return 0;
			}
		}
	}
	
	var differenceTop = cards[2].val - cards[1].val;
	var differenceLow = cards[1].val - cards[0].val;
	if ( differenceTop > 4 )
	{
		return 0;
	}
	else if ( cards[2].val > 10 && cards[1].val > 9 && cards[0].val == 1 )
	{
		// Royal straight
	}
	else if ( differenceLow > ( 4 - differenceTop ) )
	{
		return 0;
	}
	
	if ( cards[0].val == 1 && cards[2].val > 10 )
	{
		// Royal Straight
		var values = [10, 11, 12, 13];
		values.splice(values.indexOf(cards[1].val), 1);
		values.splice(values.indexOf(cards[2].val), 1);
		retCards = [ [ values[0], 'h' ], [values[1], 'c'], [cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType], [cards[0].val, cards[0].myType] ];
	}
	else
	{
		var values = [cards[0].val+1, cards[0].val+2, cards[0].val+3, cards[0].val+4];
		values.splice(values.indexOf(cards[1].val), 1);
		values.splice(values.indexOf(cards[2].val), 1);
		retCards = [ [ cards[0].val, cards[0].myType ], [cards[1].val, cards[1].myType], 
				[cards[2].val, cards[2].myType], [values[0], 'd'], [values[1], 's'] ];
	}
	return retCards;
}

function checkThreeOfAKind(cards)
{
	var retCards = [[0,0],[0,0],[0,0],[0,0],[0,0]];
	var suits = ['s', 'c', 'd', 'h'];
	if ( cards[0].val == 1 )
	{
		suits.splice(suits.indexOf(cards[0].myType),1);
		retCards = [[cards[0].val, cards[0].myType], [1, suits[0]], [1, suits[1]],
				[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType]];
	}
	else
	{
		suits.splice(suits.indexOf(cards[2].myType),1);
		retCards = [[cards[0].val, cards[0].myType], [cards[1].val, cards[1].myType], 
				[cards[2].val, cards[2].myType], [cards[2].val, suits[0]], [cards[2].val, suits[1]]];
	}
	return retCards;
}

// Evaluates the flop and the fold and returns the best hand possible. 
// Does this by going through check3cardsGivenCards() on every possibility.
function check4cards() {
	var cards = [game.river[0], game.river[1], game.river[2], game.river[3]];
	
	var poss1 = check3cardsGivenCards([cards[0], cards[1], cards[2]]);
	var poss2 = check3cardsGivenCards([cards[0], cards[1], cards[3]]);
	var poss3 = check3cardsGivenCards([cards[0], cards[2], cards[3]]);
	var poss4 = check3cardsGivenCards([cards[1], cards[2], cards[3]]);
	
	var conditions = ["Royal Flush", "Straight Flush", "Four of a kind", "Flush", "Straight", "Three of a kind"];
	if (poss1[0] == conditions[0] || poss2[0] == conditions[0] || poss3[0] == conditions[0] || poss4[0] == conditions[0] )
	{
		var counter = 0;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
	}
	else if (poss1[0] == conditions[1] || poss2[0] == conditions[1] || poss3[0] == conditions[1] || poss4[0] == conditions[1] )
	{
		var counter = 1;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
	}
	else if (poss1[0] == conditions[2] || poss2[0] == conditions[2] || poss3[0] == conditions[2] || poss4[0] == conditions[2] )
	{
		var counter = 2;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
	}
	else if (poss1[0] == conditions[3] || poss2[0] == conditions[3] || poss3[0] == conditions[3] || poss4[0] == conditions[3] )
	{
		var counter = 3;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
	}
	else if (poss1[0] == conditions[4] || poss2[0] == conditions[4] || poss3[0] == conditions[4] || poss4[0] == conditions[4] )
	{
		var counter = 4;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
	}
	else if (poss1[0] == conditions[5] || poss2[0] == conditions[5] || poss3[0] == conditions[5] || poss4[0] == conditions[5] )
	{
		var counter = 5;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
	}
	else
	{
		return "Error: This should never be reached";
	}
}

// Evaluates the flop and the fold and returns the best hand possible. 
// Does this by going through check3cardsGivenCards() on every possibility.
function check4cardsGivenCards (cards) {

	var poss1 = check3cardsGivenCards([cards[0], cards[1], cards[2]]);
	var poss2 = check3cardsGivenCards([cards[0], cards[1], cards[3]]);
	var poss3 = check3cardsGivenCards([cards[0], cards[2], cards[3]]);
	var poss4 = check3cardsGivenCards([cards[1], cards[2], cards[3]]);
	
	var conditions = ["Royal Flush", "Straight Flush", "Four of a kind", "Flush", "Straight", "Three of a kind"];
	if (poss1[0] == conditions[0] || poss2[0] == conditions[0] || poss3[0] == conditions[0] || poss4[0] == conditions[0] )
	{
		var counter = 0;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
	}
	else if (poss1[0] == conditions[1] || poss2[0] == conditions[1] || poss3[0] == conditions[1] || poss4[0] == conditions[1] )
	{
		var counter = 1;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
	}
	else if (poss1[0] == conditions[2] || poss2[0] == conditions[2] || poss3[0] == conditions[2] || poss4[0] == conditions[2] )
	{
		var counter = 2;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
	}
	else if (poss1[0] == conditions[3] || poss2[0] == conditions[3] || poss3[0] == conditions[3] || poss4[0] == conditions[3] )
	{
		var counter = 3;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
	}
	else if (poss1[0] == conditions[4] || poss2[0] == conditions[4] || poss3[0] == conditions[4] || poss4[0] == conditions[4] )
	{
		var counter = 4;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
	}
	else if (poss1[0] == conditions[5] || poss2[0] == conditions[5] || poss3[0] == conditions[5] || poss4[0] == conditions[5] )
	{
		var counter = 5;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
	}
	else
	{
		return "Error: This should never be reached";
	}
}

// Evaluates the flop, fold, and river and returns the best hand possible. 
// Does this by going through check4cardsGivenCards() on every possibility.
function check5cards() {
	var cards = [game.river[0], game.river[1], game.river[2],
			game.river[3], game.river[4]];
			
	var cardClone1 = cards.slice(0);
	var cardClone2 = cards.slice(0);
	var cardClone3 = cards.slice(0);
	var cardClone4 = cards.slice(0);
	var cardClone5 = cards.slice(0);
	
	cardClone1.splice(0,1);
	cardClone2.splice(1,1);
	cardClone3.splice(2,1);
	cardClone4.splice(3,1);
	cardClone5.splice(4,1);
	
	var poss1 = check4cardsGivenCards (cardClone1);
	var poss2 = check4cardsGivenCards (cardClone2);
	var poss3 = check4cardsGivenCards (cardClone3);
	var poss4 = check4cardsGivenCards (cardClone4);
	var poss5 = check4cardsGivenCards (cardClone5);
	
	var conditions = ["Royal Flush", "Straight Flush", "Four of a kind", "Flush", "Straight", "Three of a kind"];
	if (poss1[0] == conditions[0] || poss2[0] == conditions[0] || poss3[0] == conditions[0] || poss4[0] == conditions[0] || poss5[0] == conditions[0] )
	{
		var counter = 0;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
		else if (poss5[0] == conditions[counter])
			return poss5;
	}
	else if (poss1[0] == conditions[1] || poss2[0] == conditions[1] || poss3[0] == conditions[1] || poss4[0] == conditions[1] || poss5[0] == conditions[1] )
	{
		var counter = 1;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
		else if (poss5[0] == conditions[counter])
			return poss5;
	}
	else if (poss1[0] == conditions[2] || poss2[0] == conditions[2] || poss3[0] == conditions[2] || poss4[0] == conditions[2] || poss5[0] == conditions[2] )
	{
		var counter = 2;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
		else if (poss5[0] == conditions[counter])
			return poss5;
	}
	else if (poss1[0] == conditions[3] || poss2[0] == conditions[3] || poss3[0] == conditions[3] || poss4[0] == conditions[3] || poss5[0] == conditions[3] )
	{
		var counter = 3;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
		else if (poss5[0] == conditions[counter])
			return poss5;
	}
	else if (poss1[0] == conditions[4] || poss2[0] == conditions[4] || poss3[0] == conditions[4] || poss4[0] == conditions[4] || poss5[0] == conditions[4] )
	{
		var counter = 4;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
		else if (poss5[0] == conditions[counter])
			return poss5;
	}
	else if (poss1[0] == conditions[5] || poss2[0] == conditions[5] || poss3[0] == conditions[5] || poss4[0] == conditions[5] || poss5[0] == conditions[5] )
	{
		var counter = 5;
		if (poss1[0] == conditions[counter])
			return poss1;
		else if (poss2[0] == conditions[counter])
			return poss2;
		else if (poss3[0] == conditions[counter])
			return poss3;
		else if (poss4[0] == conditions[counter])
			return poss4;
		else if (poss5[0] == conditions[counter])
			return poss5;
	}
	else
	{
		return "Error: This should never be reached";
	}
	
}


function getWorstPossibleHandFlopOnly() {
	var cards = [game.river[0], game.river[1], game.river[2]];
	
	cards.sort (
		function(a, b) {
			var aVal;
			var bVal;
			if (a.val == 'T')
				a.val = 10;
			else if (a.val == 'J')
				a.val = 11;
			else if (a.val == 'Q')
				a.val = 12;
			else if (a.val == 'K')
				a.val = 13;
			else if (a.val == 'A')
				a.val = 1;
			aVal = a.val;
				
			if (b.val == 'T')
				b.val = 10;
			else if (b.val == 'J')
				b.val = 11;
			else if (b.val == 'Q')
				b.val = 12;
			else if (b.val == 'K')
				b.val = 13;
			else if (b.val == 'A')
				b.val = 1;
			bVal = b.val;
				
			return aVal - bVal;
		}
	);
	
	var retCards = [[0,0],[0,0],[0,0],[0,0],[0,0]];
	
	if ( cards[0].val > 4 )
	{
		// We can just use a two and a three off suit. This is the best case scenario
		retCards = [[2,'s'], [3, 'c'], [cards[0].val, cards[0].myType], 
					[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType]];
	}
	else if ( cards[0].val == 4 )
	{
		// Here, we can't just use the two lowest cards cause there might be a straight possibility (2,3,4,5,6)
		// So, we check to see if there is a straight possibility
		if (cards[1].val == 5 && cards[2].val == 6)
		{
			retCards = [[2,'c'],[cards[0].val, cards[0].myType], 
					[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType], [7, 's']];
		}
		else
		{	// There is no straight possibility, so we can just have 2, 3, 4, cards[1], cards[2]
			retCards = [[2,'c'], [3, 's'], [cards[0].val, cards[0].myType], 
					[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType]];
		}
	}
	else if ( cards[0].val == 3 )
	{
		// Check to see if straight is possible
		if ( ( cards[1].val == 4 && ( cards[2].val == 5 || cards[2].val == 6 ) ) 
				|| ( cards[1].val == 5 && cards[2].val == 6 ) )
		{
			retCards = [[2,'c'],[cards[0].val, cards[0].myType], 
					[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType], [7, 's']];
		}
		else // No straight possible. Must avoid pairing with 1 card.
		{
			if ( cards[1].val != 4 && cards[2].val != 4 )
			{
				retCards = [[2,'c'],[cards[0].val, cards[0].myType], [4, 's'], 
					[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType]];
			}
			else if ( cards[1].val != 4 ) // That means that cards[2].val must equal 4, and they have a pair of 3's
			{
				retCards = [[2,'c'],[cards[0].val, cards[0].myType], 
					[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType], [5, 's']];
			}
			else // cards[1].val == 4, and cards[2].val > 6, or else it would have been caught by the straight check
			{
				retCards = [[2,'c'],[cards[0].val, cards[0].myType], 
					[cards[1].val, cards[1].myType], [5, 's'], [cards[2].val, cards[2].myType]];
			}
			
		}
	}
	else if ( cards[0].val == 2 )
	{
		if ( cards[1].val > 5 )
		{
			retCards = [[cards[0].val,cards[0].myType],[3, 'c'], 
					[4, 's'], [cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType]];
		}
		else if (cards[1].val == 5)
		{
			if (checkStraight(cards)) // means its 2, 5, 6
			{
				retCards = [[cards[0].val,cards[0].myType],[3, 'c'], 
					[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType], [7, 's']];
			}
			else
			{
				retCards = [[cards[0].val,cards[0].myType],[3, 'c'], [4, 's'],
					[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType]];
			}
			
		}
		else if ( cards[1].val == 4 )
		{
			if ( checkStraight(cards))	// cards[2].val is either 5 or 6
			{
				retCards = [[cards[0].val,cards[0].myType],[3, 'c'], 
					[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType], [7, 's']];
			}
			else 
			{
				retCards = [[cards[0].val,cards[0].myType],[3, 'c'], 
					[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType], [7, 's']];
			}
		}
		else if ( cards[1].val == 3 )
		{
			if ( checkStraight(cards) )
			{
				if ( cards[2].val == 4 )
				{
					retCards = [[cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
							[cards[2].val, cards[2].myType], [5, 'c'], [7, 's']];
				}
				else 
				{
					retCards = [[cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
							[4, 'c'], [cards[2].val, cards[2].myType], [7, 's']];
				}
			}
			else
			{
				// cards[2].val != 4 or 5, otherwise checkStraight would have triggered
				retCards = [[cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
							[4, 'c'], [5, 's'], [cards[2].val, cards[2].myType]];
			}
		}
		else
		{
			// cards[1].val must be 2 as well. A pair. 
			if ( cards[2].val == 3 )
			{
				retCards = [[cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
					[cards[2].val, cards[2].myType], [4, 'c'], [5, 's']];
			}
			else if ( cards[2].val == 4 )
			{
				retCards = [[cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
					[cards[2].val, cards[2].myType], [3, 'c'], [5, 's']];
			}
			else
			{
				retCards = [[cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
					[cards[2].val, cards[2].myType], [3, 'c'], [4, 's']];
			}
		}
	}
	else if ( cards[0].val == 1 )
	{
		if ( checkStraight(cards) && cards[1].val > 9 ) 
		{
			retCards = [[cards[0].val,cards[0].myType], [2, 'c'], [3, 's'], [cards[1].val, cards[1].myType], 
				[cards[2].val, cards[2].myType]];
		}
		else if ( checkStraight (cards) )
		{
			if ( cards[1].val == 2 && cards[2].val == 3 )
			{
				retCards = [[cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
						[cards[2].val, cards[2].myType], [4, 'c'], [6, 's']];
			}
			else if ( cards[1].val == 2 && cards[2].val == 4 )
			{
				retCards = [[cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
						[3, 'c'], [cards[2].val, cards[2].myType], [6, 's']];
			}
			else if ( cards[1].val == 2 && cards[2].val == 5 )
			{
				retCards = [[cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
						[3, 'c'], [cards[2].val, cards[2].myType], [6, 's']];
			}
			else if ( cards[1].val == 3 && cards[2].val == 4 )
			{
				retCards = [[cards[0].val,cards[0].myType], [2, 'c'], [cards[1].val, cards[1].myType], 
						[cards[2].val, cards[2].myType], [6, 's']];
			}
			else if ( cards[1].val == 3 && cards[2].val == 5 )
			{
				retCards = [[cards[0].val,cards[0].myType], [2, 'c'], [cards[1].val, cards[1].myType], 
						[cards[2].val, cards[2].myType], [6, 's']];
			}
			else 
			{
				retCards = [[cards[0].val,cards[0].myType], [2, 'c'], [cards[1].val, cards[1].myType], 
						[cards[2].val, cards[2].myType], [6, 's']];
			}
		}
		else 
		{
			if ( cards[1].val > 4 )
			{
				retCards = [[cards[0].val,cards[0].myType], [2, 'c'], [3, 's'], 
					[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType]];
			}
			else if ( cards[1].val == 4 )
			{
				retCards = [[cards[0].val,cards[0].myType], [2, 'c'], [4, 's'], 
					[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType]];
			}
			else if ( cards[1].val == 3 )
			{
				retCards = [[cards[0].val,cards[0].myType], [2, 'c'], [cards[1].val, cards[1].myType],
					[4, 's'], [cards[2].val, cards[2].myType]];
			}
			else if ( cards[1].val == 2 )
			{
				retCards = [[cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType],
					[3, 'c'], [4, 's'], [cards[2].val, cards[2].myType]];
			}
		
		}
	}
	
}

function getWorstPossibleHandTurnOnly() {
	var cards = [game.river[0], game.river[1], game.river[2], game.river[3]];
	
	cards.sort (
		function(a, b) {
			var aVal;
			var bVal;
			if (a.val == 'T')
				a.val = 10;
			else if (a.val == 'J')
				a.val = 11;
			else if (a.val == 'Q')
				a.val = 12;
			else if (a.val == 'K')
				a.val = 13;
			else if (a.val == 'A')
				a.val = 1;
			aVal = a.val;
				
			if (b.val == 'T')
				b.val = 10;
			else if (b.val == 'J')
				b.val = 11;
			else if (b.val == 'Q')
				b.val = 12;
			else if (b.val == 'K')
				b.val = 13;
			else if (b.val == 'A')
				b.val = 1;
			bVal = b.val;
				
			return aVal - bVal;
		}
	);
	
	var retCards = [[0,0],[0,0],[0,0],[0,0],[0,0]];
	var cardVals = [ cards[0].val, cards[1].val, cards[2].val, cards[3].val];
	
	var suits = [[checkMyType(cards, 'h')], [checkMyType(cards, 'd')], [checkMyType(cards, 'c')], [checkMyType(cards, 's')]];
	var suitToAssign = 0;
	
	var flushPossible = ( suits.indexOf(4) > 0 );
	if (flushPossible)
	{
		if ( suits.indexOf(4) == 3 )
		{
			suitToAssign = suits[suitToAssign];
		}
		else
		{
			suitToAssign = suits[3];
		}
	}
	else
	{
		suitToAssign = suits[3];
	}
	
	var hasPair = 0;
	for ( var i = 0; i < cards.length-1 ; i++ )
	{
		for ( var j = 0; j < cards.length ; j++ )
		{
			if ( cards[i].val == cards[j].val )
			{
				hasPair++;
			}
		}
	}
	
	if ( !hasPair && ( ( cards[0].val + 4 == cards[3].val ) || ( cards[0].val + 3 == cards[3].val ) ))
	{
		// Normal straight possible
		if ( cards[0].val + 3 == cards[3].val )
		{
			if ( cards[0].val > 3 )
			{
				retCards = [[2,suitToAssign], [cards[0].val,cards[0].myType], 
					[cards[1].val, cards[1].myType], [cards[2].val, cards[2].myType], 
					[cards[3].val, cards[3].myType]];
			}
			else if ( cards[0].val == 3 )
			{
				retCards = [[cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType],
					 [cards[2].val, cards[2].myType], [cards[3].val, cards[3].myType], [8, suitToAssign]];
			}
			else if ( cards[0].val == 2 )
			{
				retCards = [[cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
					[cards[2].val, cards[2].myType], [cards[3].val, cards[3].myType], [7, suitToAssign]];
			}
			else
			{
				retCards = [[cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
					[cards[2].val, cards[2].myType], [cards[3].val, cards[3].myType], [6, suitToAssign]];
			}
		}
		else if ( cards[0].val + 4 == cards[3].val )
		{
			if ( cards[0].val > 2 )
			{
				retCards = [[2,suitToAssign], [cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
					[cards[2].val, cards[2].myType], [cards[3].val, cards[3].myType]];
			}
			else if ( cards[0].val == 2 )
			{
				retCards = [[7,suitToAssign], [cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
					[cards[2].val, cards[2].myType], [cards[3].val, cards[3].myType]];
			}
			else
			{
				retCards = [[6,suitToAssign], [cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
					[cards[2].val, cards[2].myType], [cards[3].val, cards[3].myType]];
			}
		}
	}
	else if ( !hasPair && (cards[0].val == 1 && cards[1].val > 9) )
	{
		// Royal straight possible.
		retCards = [[2,suitToAssign], [cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
			[cards[2].val, cards[2].myType], [cards[3].val, cards[3].myType]];
	}
	else
	{
		for ( var i = 2 ; i < 8 ; i++ )
		{
			if ( cardVals.indexOf(i) == -1 )
			{
				retCards = [[i,suitToAssign], [cards[0].val,cards[0].myType], [cards[1].val, cards[1].myType], 
					[cards[2].val, cards[2].myType], [cards[3].val, cards[3].myType]];
				i = 9;
			}
		}
	}
	
	return retCards;
	
}

function getWorstPossibleHandRiver() {

	var cards = [game.river[0], game.river[1], game.river[2], game.river[3], game.river[4]];
	
	cards.sort (
		function(a, b) {
			var aVal;
			var bVal;
			if (a.val == 'T')
				a.val = 10;
			else if (a.val == 'J')
				a.val = 11;
			else if (a.val == 'Q')
				a.val = 12;
			else if (a.val == 'K')
				a.val = 13;
			else if (a.val == 'A')
				a.val = 1;
			aVal = a.val;
				
			if (b.val == 'T')
				b.val = 10;
			else if (b.val == 'J')
				b.val = 11;
			else if (b.val == 'Q')
				b.val = 12;
			else if (b.val == 'K')
				b.val = 13;
			else if (b.val == 'A')
				b.val = 1;
			bVal = b.val;
				
			return aVal - bVal;
		}
	);

	var retCards = new Array (5);
	
	for ( var i = 0 ; i < 5 ; i++ )
	{
		retCards[i] = [cards[i].val, cards[i].myType];
	}
	return retCards;
}











