function Player () {
	this.hand = [];	// The players personal cards. Does not include the cards from the common area.
	this.bestPossibleHand = null;
	this.pot = 1000;	// Player's personal pool of funds
	this.wins = 0;		// Stats
	this.losses = 0;	// Stats
	this.folds = [0,0,0,0];		// Stats - [preflopfolds, flopfolds, turnfolds, riverfolds]
	this.ties = 0;
	this.lastMove = "";
	this.currentBet = 0;// Current bet, used for accurate betting. 
						// i.e., player bets 20, opponent bets 30, player only needs to bet 10 more. Not another 30.
	this.potAtBeginOfHand = 0; //Keeps track at the pot at the beginning of the hand.

	// Gets rid of the players hand and returns them in an array. Always return the cards to the deck with this call!
	this.discardHand = function(){
		var temp = this.hand;
		this.hand = new Array(2);
		this.lastMove = "";
		this.currentBet = 0;
		return temp;
	};

	// Take the money out of the player's personal pool, edit their bet, and return the amount bet.
	// TODO: This doesn't look right. I think it needs to have more to do with current bet. Maybe I'm crazy.
	//         Doesn't matter much now since the opponent can't raise on its own yet. As of Dec 2, 2014
	this.bet = function(x){
		var betIncrease = x - this.currentBet;
		this.pot -= betIncrease;
		this.currentBet = x;
		return (betIncrease);
	};

	// Add winnings to the player's pot, discard the player's hand, and edit their stats.
	// Returns the player's hand.
	this.win = function(x){
		this.pot += x;
		this.wins++;
		return this.discardHand();
	};

	// Called when a player folds. Edit their stats. Returns their hand.
	// PARAMETERS: x - current game state.
	this.fold = function(x){
		this.folds[x]++;
		return this.discardHand();
	}

	// Called when a player has a lesser hand than the AI. Edit their stats. Return their hand.
	this.loseHand = function(){
		this.losses++;
		return this.discardHand();
	}

	// Called when a player has a tie game.
	this.tie = function (gamePot) {
		this.pot += gamePot / 2;
		this.ties++;
		return this.discardHand();
	}
	
	// Adds a single card to the player's hand.
	this.addToHand = function(card){
		if (this.hand[0] == null)
		{
			this.hand[0] = card;
		}
		else
		{
			this.hand[1] = card;
		}
	};
	
	// Magic setter. Never used.
	this.setPot = function(pot){
		this.pot = pot;
	};
}