var express	= require('express');
var app = express();
var morgan 	= require('morgan');
var bodyParser = require('body-parser')
var methodOverride = require('method-override');
var PokerEvaluator = require("poker-evaluator");


app.use(express.static(__dirname + '/public'));
app.use(morgan('dev'));
app.use(bodyParser.urlencoded({'extended':'true'}));
app.use(bodyParser.json());
app.use(bodyParser.json({ type: 'application/vnd.api+json' }));
app.use(methodOverride());


// ================TEST ROUTES==================================
app.get('/test/evalulate3', function(req, res) {

	res.json(PokerEvaluator.evalHand(["9h", "7c", "Td"]));

});

app.get('/test/evalulate5', function(req, res) {

	res.json(PokerEvaluator.evalHand(["Qh", "Jc", "Qh", "9h", "Td"]));

});


app.get('/test/evalulate7', function(req, res) {

	res.json(PokerEvaluator.evalHand(["As", "Ks", "Qs", "Js", "Ts", "3c", "5h"]));

});

// ================PRODUCTION ROUTES==================================

app.get('/evaluate2/:card1/:card2', function(req,res){

	var card1 = req.params.card1;
	var card2 = req.params.card2;

	var sameSuit;
	var result;

	if (card1.charAt(1) == card2.charAt(1)) {
		sameSuit = 0;
	} else {
		sameSuit = 1;
	}

	if (card1.charAt(0) == 'A') {

		//Take care of poket rocket case.
		if (card2.charAt(0) == 'A') {
			result = 85.3;
		}
		//Return percentages of Ace & card2 same suit.
		//Else returns the percentages of off suit.
		else if (sameSuit == 1) {
			if (card2.charAt(0) == 'K') {
				result = 67.0;
			} else if (card2.charAt(0) == 'Q') {
				result = 66.1;
			} else if (card2.charAt(0) == 'J') {
				result = 65.4;
			} else if (card2.charAt(0) == 'T') {
				result = 64.7;
			} else if (card2.charAt(0) == 9) {
				result = 63.0;
			} else if (card2.charAt(0) == 8) {
				result = 62.1;
			} else if (card2.charAt(0) == 7) {
				result = 61.1;
			} else if (card2.charAt(0) == 6) {
				result = 60.0;
			} else if (card2.charAt(0) == 5) {
				result = 59.9;
			} else if (card2.charAt(0) == 4) {
				result = 58.9;
			} else if (card2.charAt(0) == 3) {
				result = 58.0;
			} else if (card2.charAt(0) == 2) {
				result = 57.0;
			}
		} else {
			//Ace and card2 off suit
			if (card2.charAt(0) == 'K') {
				result = 65.4;
			} else if (card2.charAt(0) == 'Q') {
				result = 64.5;
			} else if (card2.charAt(0) == 'J') {
				result = 63.6;
			} else if (card2.charAt(0) == 'T') {
				result = 62.9;
			} else if (card2.charAt(0) == 9) {
				result = 60.9;
			} else if (card2.charAt(0) == 8) {
				result = 60.1;
			} else if (card2.charAt(0) == 7) {
				result = 59.1;
			} else if (card2.charAt(0) == 6) {
				result = 57.8;
			} else if (card2.charAt(0) == 5) {
				result = 57.7;
			} else if (card2.charAt(0) == 4) {
				result = 56.4;
			} else if (card2.charAt(0) == 3) {
				result = 55.6;
			} else if (card2.charAt(0) == 2) {
				result = 55.6;
			}
		}
	} else if (card1.charAt(0) == 'K') {
		//Take care of KK case.
		if (card2.charAt(0) == 'K') {
			result = 82.4;
		} else if (sameSuit == 1) {
			if (card2.charAt(0) == 'Q') {
				result = 63.4;
			} else if (card2.charAt(0) == 'J') {
				result = 62.6;
			} else if (card2.charAt(0) == 'T') {
				result = 61.9;
			} else if (card2.charAt(0) == 9) {
				result = 60.0;
			} else if (card2.charAt(0) == 8) {
				result = 58.5;
			} else if (card2.charAt(0) == 7) {
				result = 57.8;
			} else if (card2.charAt(0) == 6) {
				result = 56.8;
			} else if (card2.charAt(0) == 5) {
				result = 55.8;
			} else if (card2.charAt(0) == 4) {
				result = 54.7;
			} else if (card2.charAt(0) == 3) {
				result = 53.8;
			} else if (card2.charAt(0) == 2) {
				result = 52.9;
			}
		} else {
			//King and card2 off suit
			if (card2.charAt(0) == 'Q') {
				result = 61.4;
			} else if (card2.charAt(0) == 'J') {
				result = 60.6;
			} else if (card2.charAt(0) == 'T') {
				result = 59.9;
			} else if (card2.charAt(0) == 9) {
				result = 58.0;
			} else if (card2.charAt(0) == 8) {
				result = 56.3;
			} else if (card2.charAt(0) == 7) {
				result = 55.4;
			} else if (card2.charAt(0) == 6) {
				result = 54.3;
			} else if (card2.charAt(0) == 5) {
				result = 53.3;
			} else if (card2.charAt(0) == 4) {
				result = 52.1;
			} else if (card2.charAt(0) == 3) {
				result = 51.2;
			} else if (card2.charAt(0) == 2) {
				result = 50.2;
			}
		}
	} else if (card1.charAt(0) == 'Q') {
		//Take care of QQ case.
		if (card2.charAt(0) == 'Q') {
			result = 79.9;
		} else if (sameSuit == 1) {
			if (card2.charAt(0) == 'J') {
				result = 60.3;
			} else if (card2.charAt(0) == 'T') {
				result = 59.5;
			} else if (card2.charAt(0) == 9) {
				result = 57.9;
			} else if (card2.charAt(0) == 8) {
				result = 56.2;
			} else if (card2.charAt(0) == 7) {
				result = 54.5;
			} else if (card2.charAt(0) == 6) {
				result = 53.8;
			} else if (card2.charAt(0) == 5) {
				result = 52.9;
			} else if (card2.charAt(0) == 4) {
				result = 51.7;
			} else if (card2.charAt(0) == 3) {
				result = 50.7;
			} else if (card2.charAt(0) == 2) {
				result = 49.9;
			}
		} else {
			//Queen and card2 off suit
			if (card2.charAt(0) == 'J') {
				result = 58.2;
			} else if (card2.charAt(0) == 'T') {
				result = 57.4;
			} else if (card2.charAt(0) == 9) {
				result = 55.5;
			} else if (card2.charAt(0) == 8) {
				result = 53.8;
			} else if (card2.charAt(0) == 7) {
				result = 51.9;
			} else if (card2.charAt(0) == 6) {
				result = 51.1;
			} else if (card2.charAt(0) == 5) {
				result = 50.2;
			} else if (card2.charAt(0) == 4) {
				result = 49.0;
			} else if (card2.charAt(0) == 3) {
				result = 47.9;
			} else if (card2.charAt(0) == 2) {
				result = 47.0;
			}
		}
	} else if (card1.charAt(0) == 'J') {
		// Take care of JJ case.
		if (card2.charAt(0) == 'J') {
			result = 77.5;
		} else if (sameSuit == 1) {
			if (card2.charAt(0) == 'T') {
				result = 57.5;
			} else if (card2.charAt(0) == 9) {
				result = 55.8;
			} else if (card2.charAt(0) == 8) {
				result = 54.2;
			} else if (card2.charAt(0) == 7) {
				result = 52.4;
			} else if (card2.charAt(0) == 6) {
				result = 50.8;
			} else if (card2.charAt(0) == 5) {
				result = 50.0;
			} else if (card2.charAt(0) == 4) {
				result = 49.0;
			} else if (card2.charAt(0) == 3) {
				result = 47.9;
			} else if (card2.charAt(0) == 2) {
				result = 47.1;
			}
		} else {
			// Jack and card2 off suit
			if (card2.charAt(0) == 'T') {
				result = 55.4;
			} else if (card2.charAt(0) == 9) {
				result = 53.4;
			} else if (card2.charAt(0) == 8) {
				result = 51.7;
			} else if (card2.charAt(0) == 7) {
				result = 49.9;
			} else if (card2.charAt(0) == 6) {
				result = 47.9;
			} else if (card2.charAt(0) == 5) {
				result = 47.1;
			} else if (card2.charAt(0) == 4) {
				result = 46.1;
			} else if (card2.charAt(0) == 3) {
				result = 45.0;
			} else if (card2.charAt(0) == 2) {
				result = 44.0;
			}
		}
	} else if (card1.charAt(0) == 'T') {
		// Take care of TT case.
		if (card2.charAt(0) == 'T') {
			result = 75.1;
		} else if (sameSuit == 1) {
			if (card2.charAt(0) == 9) {
				result = 54.3;
			} else if (card2.charAt(0) == 8) {
				result = 52.6;
			} else if (card2.charAt(0) == 7) {
				result = 51.0;
			} else if (card2.charAt(0) == 6) {
				result = 49.2;
			} else if (card2.charAt(0) == 5) {
				result = 47.2;
			} else if (card2.charAt(0) == 4) {
				result = 46.4;
			} else if (card2.charAt(0) == 3) {
				result = 45.5;
			} else if (card2.charAt(0) == 2) {
				result = 44.7;
			}
		} else {
			// 10 and card2 off suit
			if (card2.charAt(0) == 9) {
				result = 51.7;
			} else if (card2.charAt(0) == 8) {
				result = 50.0;
			} else if (card2.charAt(0) == 7) {
				result = 48.2;
			} else if (card2.charAt(0) == 6) {
				result = 46.3;
			} else if (card2.charAt(0) == 5) {
				result = 44.2;
			} else if (card2.charAt(0) == 4) {
				result = 43.4;
			} else if (card2.charAt(0) == 3) {
				result = 42.4;
			} else if (card2.charAt(0) == 2) {
				result = 41.5;
			}
		}
	} else if (card1.charAt(0) == 9) {
		// Take care of 99 case.
		if (card2.charAt(0) == 9) {
			result = 72.1;
		} else if (sameSuit == 1) {
			if (card2.charAt(0) == 8) {
				result = 51.1;
			} else if (card2.charAt(0) == 7) {
				result = 49.5;
			} else if (card2.charAt(0) == 6) {
				result = 47.7;
			} else if (card2.charAt(0) == 5) {
				result = 45.9;
			} else if (card2.charAt(0) == 4) {
				result = 43.8;
			} else if (card2.charAt(0) == 3) {
				result = 43.2;
			} else if (card2.charAt(0) == 2) {
				result = 42.3;
			}
		} else {
			// 9 and card2 off suit
			if (card2.charAt(0) == 8) {
				result = 48.4;
			} else if (card2.charAt(0) == 7) {
				result = 46.7;
			} else if (card2.charAt(0) == 6) {
				result = 44.9;
			} else if (card2.charAt(0) == 5) {
				result = 42.9;
			} else if (card2.charAt(0) == 4) {
				result = 40.7;
			} else if (card2.charAt(0) == 3) {
				result = 39.9;
			} else if (card2.charAt(0) == 2) {
				result = 38.9;
			}
		}
	} else if (card1.charAt(0) == 8) {
		// Take care of 88 case.
		if (card2.charAt(0) == 8) {
			result = 69.1;
		} else if (sameSuit == 1) {
			if (card2.charAt(0) == 7) {
				result = 48.2;
			} else if (card2.charAt(0) == 6) {
				result = 46.5;
			} else if (card2.charAt(0) == 5) {
				result = 44.8;
			} else if (card2.charAt(0) == 4) {
				result = 42.7;
			} else if (card2.charAt(0) == 3) {
				result = 40.8;
			} else if (card2.charAt(0) == 2) {
				result = 40.3;
			}
		} else {
			// 8 and card2 off suit
			if (card2.charAt(0) == 7) {
				result = 45.5;
			} else if (card2.charAt(0) == 6) {
				result = 43.6;
			} else if (card2.charAt(0) == 5) {
				result = 41.7;
			} else if (card2.charAt(0) == 4) {
				result = 39.6;
			} else if (card2.charAt(0) == 3) {
				result = 37.5;
			} else if (card2.charAt(0) == 2) {
				result = 38.8;
			}
		}
	} else if (card1.charAt(0) == 7) {
		// Take care of 77 case.
		if (card2.charAt(0) == 7) {
			result = 66.2;
		} else if (sameSuit == 1) {
			if (card2.charAt(0) == 6) {
				result = 45.7;
			} else if (card2.charAt(0) == 5) {
				result = 43.8;
			} else if (card2.charAt(0) == 4) {
				result = 41.8;
			} else if (card2.charAt(0) == 3) {
				result = 40.0;
			} else if (card2.charAt(0) == 2) {
				result = 38.1;
			}
		} else {
			// 7 and card2 off suit
			if (card2.charAt(0) == 6) {
				result = 42.7;
			} else if (card2.charAt(0) == 5) {
				result = 40.8;
			} else if (card2.charAt(0) == 4) {
				result = 38.6;
			} else if (card2.charAt(0) == 3) {
				result = 36.6;
			} else if (card2.charAt(0) == 2) {
				result = 34.6;
			}
		}
	} else if (card1.charAt(0) == 6) {
		// Take care of 66 case.
		if (card2.charAt(0) == 6) {
			result = 63.3;
		} else if (sameSuit == 1) {
			if (card2.charAt(0) == 5) {
				result = 43.2;
			} else if (card2.charAt(0) == 4) {
				result = 41.4;
			} else if (card2.charAt(0) == 3) {
				result = 39.4;
			} else if (card2.charAt(0) == 2) {
				result = 37.5;
			}
		} else {
			// 6 and card2 off suit
			if (card2.charAt(0) == 5) {
				result = 40.1;
			} else if (card2.charAt(0) == 4) {
				result = 38.0;
			} else if (card2.charAt(0) == 3) {
				result = 35.9;
			} else if (card2.charAt(0) == 2) {
				result = 34.0;
			}
		}
	} else if (card1.charAt(0) == 5) {
		// Take care of 55 case.
		if (card2.charAt(0) == 5) {
			result = 60.3;
		} else if (sameSuit == 1) {
			if (card2.charAt(0) == 4) {
				result = 41.1;
			} else if (card2.charAt(0) == 3) {
				result = 39.3;
			} else if (card2.charAt(0) == 2) {
				result = 37.5;
			}
		} else {
			// 5 and card2 off suit
			if (card2.charAt(0) == 4) {
				result = 37.9;
			} else if (card2.charAt(0) == 3) {
				result = 35.8;
			} else if (card2.charAt(0) == 2) {
				result = 33.9;
			}
		}
	} else if (card1.charAt(0) == 4) {
		// Take care of 44 case.
		if (card2.charAt(0) == 4) {
			result = 57.0;
		} else if (sameSuit == 1) {
			if (card2.charAt(0) == 3) {
				result = 38.0;
			} else if (card2.charAt(0) == 2) {
				result = 36.3;
			}
		} else {
			// 4 and card2 off suit
			if (card2.charAt(0) == 3) {
				result = 34.4;
			} else if (card2.charAt(0) == 2) {
				result = 32.5;
			}
		}
	} else if (card1.charAt(0) == 3) {
		// Take care of 33 case.
		if (card2.charAt(0) == 3) {
			result = 53.7;
		} else if (sameSuit == 1) {
			if (card2.charAt(0) == 2) {
				result = 35.1;
			}
		} else {
			// 5 and card2 off suit
			if (card2.charAt(0) == 2) {
				result = 31.2;
			}
		}
	} else if (card1.charAt(0) == 2) {
		// Take care of 33 case.
		if (card2.charAt(0) == 2) {
			result = 50.3;
		}
	}
	console.log(result);
	console.log(card1 + " " + card2);
	res.json(result);
});

//FLOP START
app.get('/evaluate5/:user1/:user2/:river1/:river2/:river3', function(req, res){
	var user1 = formatString(req.params.user1);
	var user2 = formatString(req.params.user2);
	var river1 = formatString(req.params.river1);
	var river2 = formatString(req.params.river2);
	var river3 = formatString(req.params.river3);
	var eval = PokerEvaluator.evalHand([user1, user2, river1, river2, river3]);
	res.json(eval.value);
});

app.get('/lowest3/:river1/:river2/:river3',function(req, res){
	var river1 = formatString(req.params.river1);
	var river2 = formatString(req.params.river2);
	var river3 = formatString(req.params.river3);
	var eval = PokerEvaluator.evalHand([river1, river2, river3]);
	res.json(eval.value);
});

//FLOP END

app.get('/evaluate6/:user1/:user2/:river1/:river2/:river3/:river4', function(req, res){
	var eval;
	res.json("Feature need to be implemented");
});

app.get('/evaluate7/:user1/:user2/:river1/:river2/:river3/:river4/:river5', function(req, res){
	var eval = PokerEvaluator.evalHand([req.params.user1, req.params.user2,
		req.params.river1, req.params.river2, req.params.river3, req.params.river4, req.params.river5]);
	res.json(eval.value);
});

// ================HTML ROUTES==================================

app.get('/', function(req, res) {
	res.sendfile('./public/index.html'); // load the single view file
});

app.get('/test', function(req, res) {
	res.sendfile('./public/test.html'); // load the single view file
});


// ================PORT==================================

app.listen(3000, function(){
	console.log("App listening on port 3000");
});

// ================UTILITY FUNCTIONS==================================

function formatString(card){
	switch(card){
		case "10":
			return "T";
			break;
		case "11":
			return "J";
			break;
		case "12":
			return "Q";
			break
		case "13":
			return "K";
			break;
		case "1":
			return "A";
			break
		default:
			return card;
	}
}